diff --git a/src/pl/tcl/pltcl.c b/src/pl/tcl/pltcl.c
new file mode 100644
index ae9ba80..e6bf9bb
*** a/src/pl/tcl/pltcl.c
--- b/src/pl/tcl/pltcl.c
*************** compile_pltcl_function(Oid fn_oid, Oid t
*** 1395,1401 ****
  	 * function's pg_proc entry without changing its OID.
  	 ************************************************************/
  	if (prodesc != NULL &&
! 		prodesc->fn_xmin == HeapTupleHeaderGetRawXmin(procTup->t_data) &&
  		ItemPointerEquals(&prodesc->fn_tid, &procTup->t_self))
  	{
  		/* It's still up-to-date, so we can use it */
--- 1395,1401 ----
  	 * function's pg_proc entry without changing its OID.
  	 ************************************************************/
  	if (prodesc != NULL &&
! 		prodesc->fn_xmin == HeapTupleGetRawXmin(procTup) &&
  		ItemPointerEquals(&prodesc->fn_tid, &procTup->t_self))
  	{
  		/* It's still up-to-date, so we can use it */
*************** compile_pltcl_function(Oid fn_oid, Oid t
*** 1462,1468 ****
  		prodesc->internal_proname = pstrdup(internal_proname);
  		prodesc->fn_cxt = proc_cxt;
  		prodesc->fn_refcount = 0;
! 		prodesc->fn_xmin = HeapTupleHeaderGetRawXmin(procTup->t_data);
  		prodesc->fn_tid = procTup->t_self;
  		prodesc->nargs = procStruct->pronargs;
  		prodesc->arg_out_func = (FmgrInfo *) palloc0(prodesc->nargs * sizeof(FmgrInfo));
--- 1462,1468 ----
  		prodesc->internal_proname = pstrdup(internal_proname);
  		prodesc->fn_cxt = proc_cxt;
  		prodesc->fn_refcount = 0;
! 		prodesc->fn_xmin = HeapTupleGetRawXmin(procTup);
  		prodesc->fn_tid = procTup->t_self;
  		prodesc->nargs = procStruct->pronargs;
  		prodesc->arg_out_func = (FmgrInfo *) palloc0(prodesc->nargs * sizeof(FmgrInfo));
diff --git a/src/test/regress/regress.c b/src/test/regress/regress.c
new file mode 100644
index 6b13103..f444fc5
*** a/src/test/regress/regress.c
--- b/src/test/regress/regress.c
*************** make_tuple_indirect(PG_FUNCTION_ARGS)
*** 755,760 ****
--- 755,761 ----
  	tuple.t_len = HeapTupleHeaderGetDatumLength(rec);
  	ItemPointerSetInvalid(&(tuple.t_self));
  	tuple.t_tableOid = InvalidOid;
+ 	HeapTupleSetZeroBase(&tuple);
  	tuple.t_data = rec;
  
  	values = (Datum *) palloc(ncolumns * sizeof(Datum));
diff --git a/src/test/regress/sql/alter_table.sql b/src/test/regress/sql/alter_table.sql
new file mode 100644
index 5dd1402..92cd15e
*** a/src/test/regress/sql/alter_table.sql
--- b/src/test/regress/sql/alter_table.sql
*************** from pg_locks l join pg_class c on l.rel
*** 1425,1431 ****
  where virtualtransaction = (
          select virtualtransaction
          from pg_locks
!         where transactionid = txid_current()::integer)
  and locktype = 'relation'
  and relnamespace != (select oid from pg_namespace where nspname = 'pg_catalog')
  and c.relname != 'my_locks'
--- 1425,1431 ----
  where virtualtransaction = (
          select virtualtransaction
          from pg_locks
!         where transactionid = txid_current())
  and locktype = 'relation'
  and relnamespace != (select oid from pg_namespace where nspname = 'pg_catalog')
  and c.relname != 'my_locks'
*************** from pg_locks l join pg_class c on l.rel
*** 1512,1518 ****
  where virtualtransaction = (
          select virtualtransaction
          from pg_locks
!         where transactionid = txid_current()::integer)
  and locktype = 'relation'
  and relnamespace != (select oid from pg_namespace where nspname = 'pg_catalog')
  and c.relname = 'my_locks'
--- 1512,1518 ----
  where virtualtransaction = (
          select virtualtransaction
          from pg_locks
!         where transactionid = txid_current())
  and locktype = 'relation'
  and relnamespace != (select oid from pg_namespace where nspname = 'pg_catalog')
  and c.relname = 'my_locks'
